﻿
using System;
using System.Collections.Generic;
using Wisej.Web;

namespace TestingListView {
    public partial class Window1 : Form {

        public class DeviceDTO {

            public int DeviceID { get; set; }
            public string DeviceName { get; set; }
            public DeviceTypes DeviceType { get; set; }

        }

        public enum DeviceTypes {
           Type1=0,
           Type2,
           Type3
                
        }
        /// <summary>
        /// Next Device ID
        /// </summary>
        int m_nextDeviceID = 11;


        public Window1() {
            InitializeComponent();
        }

        private void buttonPopulateInitialValues_Click(object sender, EventArgs e) {

            var deviceList = new List<DeviceDTO>();

            deviceList.Add(new DeviceDTO() { DeviceID = 1, DeviceName = "Device 1", DeviceType = DeviceTypes.Type1 });
            deviceList.Add(new DeviceDTO() { DeviceID = 2, DeviceName = "Device 2", DeviceType = DeviceTypes.Type2 });
            deviceList.Add(new DeviceDTO() { DeviceID = 3, DeviceName = "Device 3", DeviceType = DeviceTypes.Type3 });
            deviceList.Add(new DeviceDTO() { DeviceID = 4, DeviceName = "Device 4", DeviceType = DeviceTypes.Type1 });
            deviceList.Add(new DeviceDTO() { DeviceID = 5, DeviceName = "Device 5", DeviceType = DeviceTypes.Type2 });
            deviceList.Add(new DeviceDTO() { DeviceID = 6, DeviceName = "Device 6", DeviceType = DeviceTypes.Type3 });
            deviceList.Add(new DeviceDTO() { DeviceID = 7, DeviceName = "Device 7", DeviceType = DeviceTypes.Type1 });
            deviceList.Add(new DeviceDTO() { DeviceID = 8, DeviceName = "Device 8", DeviceType = DeviceTypes.Type1 });
            deviceList.Add(new DeviceDTO() { DeviceID = 9, DeviceName = "Device 9", DeviceType = DeviceTypes.Type3 });
            deviceList.Add( new DeviceDTO() { DeviceID = 10, DeviceName = "Device 10", DeviceType = DeviceTypes.Type1 });

            foreach( var device in deviceList ) {

                var newListViewItem = new ListViewItem();

                switch( device.DeviceType ) {

                    case DeviceTypes.Type1:
                        newListViewItem.ImageIndex = 0;
                        break;
                    case DeviceTypes.Type2:
                        newListViewItem.ImageIndex = 1;
                        break;
                    case DeviceTypes.Type3:
                        newListViewItem.ImageIndex = 2;
                        break;

                }

                newListViewItem.RowHeight = 20;

                newListViewItem.SubItems.Add(device.DeviceName);

                listDevices.Items.Add(newListViewItem);

            }

        }

        private void buttonInsertNewValue_Click(object sender, EventArgs e) {

            var newListViewItem = new ListViewItem();

            var newDevice = new DeviceDTO() { DeviceID = m_nextDeviceID, DeviceName = $"Device {m_nextDeviceID}", DeviceType = DeviceTypes.Type1 };

            switch (newDevice.DeviceType) {

                case DeviceTypes.Type1:
                    newListViewItem.ImageIndex = 0;
                    break;
                case DeviceTypes.Type2:
                    newListViewItem.ImageIndex = 1;
                    break;
                case DeviceTypes.Type3:
                    newListViewItem.ImageIndex = 2;
                    break;

            }

            m_nextDeviceID++;

            listDevices.FocusedItem = null;

            newListViewItem.RowHeight = 20;

            newListViewItem.SubItems.Add(newDevice.DeviceName);

            listDevices.Items.Insert(0,newListViewItem);

            listDevices.Items[0].Selected = true;
            listDevices.Items[1].Selected = true;
            listDevices.Items[2].Selected = true;

            listDevices.FocusedItem = listDevices.Items[0];
            listDevices.FocusedItem = listDevices.Items[1];
            listDevices.FocusedItem = listDevices.Items[2];

        }
    }
}
